#include "PSO.h"

extern PegBitmap gbcircuitBitmap;

PSO::PSO(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
init();
}

int PSO::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;
    
    PegRect rectangle;
    PEGCHAR* chrohm = "\xEC\x7E"; 
     
 	PegPrompt* label1 = new PegPrompt(margin, 60, width, "Fases:",0,wStyle);
	n = new CPPegString(margin+37,60,30,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(n);
	AddR(label1);
	
 	PegPrompt* label2 = new PegPrompt(margin, 75, width, "C(nF):",0,wStyle);
	C = new CPPegString(margin+37,75,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(C);
	AddR(label2);
	
 	PegPrompt* label3 = new PegPrompt(margin, 90, width, "R(k"+CPString(chrohm)+"):",0,wStyle);
	R = new CPPegString(margin+37,90,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(R);
	AddR(label3);
	
 	PegPrompt* label4 = new PegPrompt(margin, 105, width, "Rin(k"+CPString(chrohm)+"):",0,wStyle);
	Rin = new CPPegString(margin+45,105,width - 78,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(Rin);
	AddR(label4);
	
 	PegPrompt* label5 = new PegPrompt(82, 60, width, "Vz(V):",0,wStyle);
	Vz = new CPPegString(118,60,30,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(Vz);
	AddR(label5);
	
     //rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);
    rectangle.Set(25, 120, 90, 135);
   	PegTextButton* b3 = new PegTextButton(rectangle, "Calcular!", BOTO, AF_ENABLED|TJ_CENTER);
	AddR(b3);
	
    rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_TOP+60);
 	PegBitmapButton * imatge = new PegBitmapButton(rectangle,&gbcircuitBitmap,0,AF_TRANSPARENT,TYPE_PROMPT,FALSE);
 	AddR(imatge); 
 	
    rectangle.Set(10, 140, MAINFRAME_RIGHT-10, 185); 
    results = new PegVertList(rectangle,ID_RESULTS);
    results->SetScrollMode(WSM_AUTOVSCROLL); 
    AddR(results);
    
	return 0;
}

void PSO::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED PSO::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
		case SIGNAL(BOTO, PSF_CLICKED):
		{
             Calcula();
		}
		break;
		
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

WORD PSO::Dialog(char* title, char* message)
{
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}

void PSO::Calcula()
{
    OBCD Raux,Caux,aux1,aux2,aux3,G;
    short i,j;
    PEGCHAR* chrohm = "\xEC\x7E"; 
 
    results->Clear();

    Raux = CPExpression(R->DataGet());
    ExecuteToOBCD("1000",aux1);
    Cal_mul_OBC(&Raux,&aux1);
    
    Caux = CPExpression(C->DataGet());
    ExecuteToOBCD("1000000000",aux1);
    Cal_div_OBC(&Caux,&aux1);
    
    // Calcula la frecuencia
    Cal_setpi_OBC(&aux1);
    aux2 = CPExpression(n->DataGet());
    Cal_div_OBC(&aux1,&aux2);
    Cal_tan_OBC(&aux1,GSETUP_Angle_Rad);
    Cal_set2pi_OBC(&aux2);
    Cal_div_OBC(&aux1,&aux2);
    Cal_div_OBC(&aux1,&Raux);
    Cal_div_OBC(&aux1,&Caux);
    
    results->AddToEnd(new PegPrompt(0, 0, "f = "+CPString(aux1)+" Hz", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
    
    G = aux1;
    Cal_set2pi_OBC(&aux1);
    Cal_mul_OBC(&G,&aux1);
    Cal_mul_OBC(&G,&Raux);
    Cal_mul_OBC(&G,&Caux);
    Cal_square_OBC(&G);
    Cal_setn_OBC(1,&aux1);
    Cal_add_OBC(&G,&aux1);
    Cal_sqrt_OBC(&G);
    Cal_inverse_OBC(&G);

    aux1 = CPExpression(n->DataGet());
    Cal_toshort_OBC(&aux1,&j);
    
    aux1 = CPExpression(Vz->DataGet());
    ExecuteToOBCD("0.6",aux2);
    Cal_add_OBC(&aux1,&aux2);
    
    CPString subindex;
    for(i=0;i<=j;i++)
    {
        aux2 = G;
        aux3 = CPExpression(i);
        Cal_pow_OBC(&aux2,&aux3);
        Cal_mul_OBC(&aux2,&aux1);
        subindex = (i==0)?CPString("o"):CPString(aux3);
        results->AddToEnd(new PegPrompt(0, 0, "V"+subindex+" = "+CPString(aux2)+" V", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));    
    }

    Cal_div_OBC(&aux1,&aux2);
    results->AddToEnd(new PegPrompt(0, 0, "Av = "+CPString(aux1)+" ", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));    

    aux2 = CPExpression(Rin->DataGet());
    Cal_mul_OBC(&aux1,&aux2);
    results->AddToEnd(new PegPrompt(0, 0, "Rf = "+CPString(aux1)+" k"+CPString(chrohm), 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));    

    Draw();
}   

extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}
